Notification area whitelist is obsolete

Bug #974480 reported by Matthew Paul Thomas on 2012-04-05
326
This bug affects 65 people
Affects Status Importance Assigned to Milestone
Ayatana Design
High
Unassigned
Unity
Fix Released
High
Andrea Azzarone
unity (Ubuntu)
High
Andrea Azzarone

Bug Description

Mark has asked us to consider retiring the notification area whitelist for 12.10. The application indicator system has been in place for two years now, which should be long enough for applications to adopt it.

If the whitelist was retired, Java and Wine would be hard-coded as the only software still able to use the menu bar as if it was a notification area, because their developers don't necessarily know that Ubuntu even exists.

Related branches

John Lea (johnlea) on 2012-04-25
summary: - Notification area whitelist may be obsolete
+ Remove Notification area whitelist in 12.10
Changed in ayatana-design:
assignee: nobody → John Lea (johnlea)
importance: Undecided → High
assignee: John Lea (johnlea) → Matthew Paul Thomas (mpt)
status: New → Triaged
tags: added: udp
Changed in unity:
status: New → Triaged
Changed in unity (Ubuntu):
status: New → Triaged
Changed in unity:
milestone: none → backlog
John Lea (johnlea) on 2012-04-25
Changed in unity:
importance: Undecided → High
Changed in unity (Ubuntu):
importance: Undecided → High

That seems like a bad idea, users are still complaining about broken softwares, including spotify from the bug triaging I did this week, not that we current offer a good user experience, we just screw those users and isv, but dropping the whitelist is a step further in that direction

I gotta agree with Sebastien; this seems like a horrible idea. There are apps that will *never* directly support Unity's notification area, but work fine with whitelisting. I regularly use at least three that I had to whitelist manually.

The only reason to remove the option of whitelisting would be to force technical users to decide to either stop using those programs (many of which need a working tray icon to be useful) or stop using Unity. If you want people to have a valid reason (freedom of choice in applications) to bash Unity in favor of every other desktop available, go for it.

Christo Swanepoel (css-private) wrote :

I also agree with the previous two posts.

If we have to stop using the system tray icon, what does Canonical suggest we should use?

I can only think of splitting the application into two parts. A service and a UI with the UI managing the service.

This might be big changes and add up on the cost to the company. It also makes supporting multiple OS much more complicated than it needs to be.

In my opinion it we'll need to do a redesign and do a complete rewrite of the application to do a good job of it.

Andrea Azzarone (azzar1) on 2012-09-13
Changed in unity:
assignee: nobody → Andrea Azzarone (andyrock)
Changed in unity (Ubuntu):
assignee: nobody → Andrea Azzarone (andyrock)
Andrea Azzarone (azzar1) on 2012-09-13
Changed in unity:
status: Triaged → In Progress
Changed in unity (Ubuntu):
status: Triaged → In Progress
Tim Penhey (thumper) on 2012-09-14
Changed in unity:
milestone: backlog → none
Tim Penhey (thumper) on 2012-09-14
tags: added: exbacklog
Andrea Agnolin (agno94) wrote :

Also libreoffice quickstart needs the notification area to be seen.

John Lea (johnlea) on 2012-09-19
Changed in ayatana-design:
status: Triaged → Fix Committed
John Lea (johnlea) on 2012-09-19
summary: - Remove Notification area whitelist in 12.10
+ Menu Bar - Remove Notification area whitelist in 12.10
summary: - Menu Bar - Remove Notification area whitelist in 12.10
+ Notification area whitelist is obsolete
Andrea Azzarone (azzar1) on 2013-02-06
Changed in unity:
milestone: none → 7.0.0
Changed in unity:
status: In Progress → Fix Committed
Andrea Azzarone (azzar1) on 2013-02-07
Changed in unity (Ubuntu):
status: In Progress → Fix Committed
Changed in ayatana-design:
assignee: Matthew Paul Thomas (mpt) → nobody
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package unity - 6.12.0daily13.02.07-0ubuntu1

---------------
unity (6.12.0daily13.02.07-0ubuntu1) raring; urgency=low

  [ Andrea Azzarone ]
  * make check fails on test-unit (LP: #1117487)
  * Notification area whitelist is obsolete (LP: #974480)

  [ Marco Trevisan (Treviño) ]
  * Switcher - when opening in detail mode (Alt+`) it should not use the
    spread animation (LP: #1116927)
  * Alt-tab sometimes focuses a window that is not in top of the app
    stack (LP: #1115775)
  * Switcher: Opening and closing the detail mode quickly makes unity
    re-enable it (LP: #1116785)
  * Exiting expo mode leaves the BFB quicklist open (LP: #1090565)

  [ MC Return ]
  * unmaximize_window_key instead of unmaximize_or_minimize_window_key
    exposed in g-c-c (LP: #1115128)

  [ Automatic PS uploader ]
  * Automatic snapshot from revision 3136
 -- Automatic PS uploader <email address hidden> Thu, 07 Feb 2013 06:20:12 +0000

Changed in unity (Ubuntu):
status: Fix Committed → Fix Released
Ed Guenter (edgue) wrote :

Thanks for breaking the 5000+ Ubuntu users within our company that "enjoy" using such ancient applications like Sametime, Lotus Notes or Symantec Antivirus. Maybe, in 5 years from now, such applications will accept that unity exist and provide indicators. Today, they dont. Or maybe unity is history in 5 years from now.

One of the few reasons I found to convince myself to dig into Unity was the fact that such icons would work a bit better than on KDE. Now you really took away one of the remaining "advantages" of Unity.

Excellent job. Thank you!

asmodey (pavel-finkelshtein) wrote :

What about my wine and java apps?

Mike M (hairy-palms-19) wrote :

so i now have to either revert this commit and compile myself or switch to a proper desktop environment, it also makes it that much harder to write cross platform gtk applications since statusicon is what windows and most other desktop environments support.

This is a good move. Developers have had plenty of time to update to new standards and features. Dropping support for this, sort of hack, promotes proper development for the future.

Ed,

That's what LTS releases are for. Ubuntu 12.04 is going anywhere anytime soon. If the software your business is using is really that ancient, and these applications are no longer being developed, then maybe the problem doesn't lie with the this bug...

This is just my opinion, but if you insist on relying so much on those proprietary software, why are you using Ubuntu in the first place? Kind of missing the point, no?

Wine and Java apps are still supported.

Bear in mind that third-party software isn't all developed on Ubuntu. It's patently unreasonable to try to force third-party developers to code specially for Ubuntu. It seems rather arrogant for Ubuntu to try to dictate to third-party developers their own idea of best practices.

What's the harm in leaving the whitelist as long as even one app uses it? (It should have been created as a blacklist from the beginning, but that's water under the bridge now.)

I've also noted that all of the comments on this bug save two have been negative, yet the developers don't feel compelled to defend their decision in the face of strong opposition.

On 02/08/2013 11:32 AM, Scott Severance wrote:
> I've also noted that all of the comments on this bug save two have been
> negative, yet the developers don't feel compelled to defend their
> decision in the face of strong opposition.

Scott, if you could articulate the approach you think would be
appropriate to delivering a better user experience over time, that would
be appreciated.

In this case:

 * user testing supports the view that the indicators are a much better
experience than the old notification area
 * the new experience was introduced in 2009, it is now 2013
 * in the interim we have supported the old experience, providing a
large window for developers that care about Ubuntu users to adopt the
better API and experience
 * developers that do not care about Ubuntu users will not respond to
any other issues you may find in their software
 * we continue to maintain, at my expense, older versions of Ubuntu
compatible with the notification area

If you're offering to do the work, that's fine, but if you're insisting
that others do work for you, and have no proposal for how you would see
the platform evolve to get better over time, then please recognise the
paucity of your arguments. Finally, don't conflate a reluctance to have
the same argument endlessly with a reluctance to make a case. You'll
find our position clearly articulated here and elsewhere, we're just
reluctant to have to restate it every time, and be called names, when we
could be making an amazing experience that competes with Windows8 and
Android and MacOS ;)

Mark

Cheers I appreciate that you are now pushing me off Ubuntu. I have work applications that are never going to use appindicators.

Jason Donahue (timekiller) wrote :

This causes a real problem with Gtk Perl applications. There are no Perl modules to create indicators for Gtk3 (that I could find). All I could find was Gtk2::AppIndicator. You are effectively forcing Perl developers to Gtk2 rather than allowing us to move forward to Gtk3 development. This halts development of new programs that culd take advantage of the new library because you are imposing an arbitrary requirement that not all environment yet support.

Until there is a full suite of functionality for Gtk3, removing any backwards compatibility just hurts developers and users alike. Ask yourselves this: Who/what is being hurt by allowing the whitelist to exist ?

Paul Sladen (sladen) wrote :

Chris: which (precise) applications that you use for work do not support the Unity global menu?

For example, for myself, there are two applications without have global menu support:

  1. JOSM (OpenStreetMap editor, Java-based owing to portability)
  2. Fontforge (purely custom widget set, owing to age and other widgets sets not then supporting Unicode reliably)

that said, neither of these use the menubar for status (so I think the difference would be null here).

Mark Shuttleworth (sabdfl) wrote :

Chris, Jason, have you asked the developers to consider the bindings you
need?

Mike M (hairy-palms-19) wrote :

to be fair, its not asking for additional work, merely to keep the existing work active, the default of only whitelisting java and wine keeps the same experience unless the user explicitly overrides it, and those overrides are staying in hard-coded form.

Dylan Taylor (dylanmtaylor) wrote :

Wow, I can't thank you guys enough for _completely breaking AutoKey_, as well as several other legacy applications that will probably never add AppIndicator support. There is no way that this bug was making managing the code more difficult, but it definitely will be a burden to people who rely on applications withot AppIndicator support.

Jason Donahue (timekiller) wrote :

Mark,
The Perl Gtk3 libraries are still very much a work in progress. A lot of functionality is there, but it is still not feature complete. We are talking about a rich history of code that needs to be ported. CPAN shows Gtk2 dating back to 2003, and had new code committed as recently as 5 days ago. It will take time to bring even the core functionality over. And now you are suggesting I reach out to the maintainers and ask them to stop what they are doing and build this particular peice for one distro, albeit a popular one. In your own words:

If you're offering to do the work, that's fine, but if you're insisting
that others do work for you, and have no proposal for how you would see
the platform evolve to get better over time, then please recognise the
paucity of your arguments.

I can appreciate your desire to move away from the "old" way and have developers update their programs to adopt your way, but in this case that simply isn't possible yet. You are breaking functionality arbitrarily. More and more it feels like in the Ubuntu team's desire to open Linux to a more mainstream audience, they are alienating it's core users.

My application needed for work that had to be white listed.
Lotus Notes, Lotus Sametime, Symantic AV, A couple of internal security tools all corporate. Without these I cant use Ubuntu at work so it will be off to RHEL or Windows. What's even more annoying is I just took a some of my co-workers through a demo of Ubuntu and how its better than anything else around and now I have to go back to them and tell sorry but you guys cant use this cool stuff because they just broke it, deliberately

MC Return (mc-return) wrote :

Pidgin and Guake also still need whitelisting...

James Cole (intangi) wrote :

Wow, what a terribly short-sighted egotistical decision...

So the POV is: only Ubuntu specific Linux software will be usable on Ubuntu going forward (even the whitelist approach while already stupid, and intentionally hidden to confuse non technical users into not using apps that don't write Ubuntu specific version, at least it was an option for those of us who use many non Ubuntu specific apps by choice and sometimes by mandate).

Why break usability of existing software to remove a list in a hidden setting (because the code is still there indefinitely for Wine and Java apps) for _no_reason_at_all_ Great... Well, Cinnamon is getting better every day...

ThomasLee82 (kamiyasha) wrote :

Though I don't have any software that requires a whitelist that I personally use (and work is Windows-only), I still feel that removing the whitelist is a step backwards.

From what I've been able to ascertain, the whitelist itself takes a minimal amount of code (I've heard 55 LOC), and provides more than its weight in functionality.

Please, for the sake of corporate users (ex: Ed Guenter), reconsider.

Marius B. Kotsbak (mariusko) wrote :

I believe Pidgin is compatible with the indicators.

MC Return (mc-return) wrote :

mariusko, here the latest Pidgin version just has the option "System Tray Icon", but this option does not work anymore and I cannot find any indicator options...

Jakob Schmitt (jakob-schmitt) wrote :

There are some popular cross platform apps like Truecrypt and Dragondisk without indicator support.

Vino also needs whitelisting because otherwise you won't recognise established remote desktop connections.

Gnome Phone Manager, Artha, Cryptkeeper - just to mention some other Linux apps which rely on a tray symbol and have no indicator support, too.

Paul Sladen (sladen) wrote :

James: I think a lot of it is about "works with Ubuntu" vs. "works against some APIs that were made 10 years ago, and which most/some Unices' Windows Managers have supported at some time". For stuff to work with *the Ubuntu experience* some effort will be required; this is much the same as following the HIG on Mac OSX. [*]

I'm tempted to suggest that the way to go with this is to have a separate application (_not_ part of the Unity, or Ubuntu APIs) which provides a implementation of the tray manager end per:

  http://www.freedesktop.org/wiki/Specifications/systemtray-spec

and which punts those requestes to a "regular" application window near a corner. Anything using the Systray API is not introspectable, it's not accessible and it's not really suitable for providing the depth of metadata necessary for the interface or for those who cannot see a grid of pixels. However, a separate implementation of the tray manager API would provide a legacy solution, and the .deb Recommends can pull in that shim when it's required so that it's only installed when such applications are pulled in.

[*] The counter for this would be that both Microsoft and the Linux kernel have succeeded for twenty years with prioritising mostly-reliable handling of previous generations of APIs. A separate shim application here would provide somewhere reasonably sandboxed to let legacy apps draw into their legacy raw container windows, while making it clear that these aren't a "supported" solution going forward, and importantly would get that code out of the Unity menubar implementation.

Jorge Castro (jorge) wrote :

Jason Donahue,

Shutter (the screenshot app) is Perl and has appindicator support, I don't know the implementation details but you could perhaps ping the author of the application: https://launchpad.net/~mario-kemper

Maybe there's a workaround we can post on the appindicator specs pages for Perl apps.

Paddy Landau (paddy-landau) wrote :

Oh man, I've just come across this bug as a result of testing 13.04 and, along with a number of other people, finding serious problems with this.

It is a terrible decision!

Why?

1. "If the whitelist was retired, Java and Wine would be hard-coded as the only software still able to use the menu bar as if it was a notification area, because their developers don't necessarily know that Ubuntu even exists."

But what about other developers who do not know or care about Ubuntu?

2. "If the whitelist was retired, Java and Wine would be hard-coded…"

Clearly Mark does not know about proper programming practice. Hard-coding parameters was deprecated in the early 1980's.

3. "If the whitelist was retired, Java and Wine would be hard-coded…"

That does not increase freedom — it does the exact opposite. For Mark to try to predict which applications users may need to white-list is short-sighted. As Niels Bohr said, "Prediction is very difficult, especially about the future."

4. There are some well-respected and popular applications (such as TrueCrypt) that will no longer work when 13.04 comes around. Imagine the backlash. It's easy to say, "Oh, well, the application developers should change their code", but seriously, Canonical does not employ them. We depend on their goodwill and their time (not all developers are paid for their work).

Implementing this "feature" is unfortunate, and needs to be removed as a regression bug. Please, please, please keep the parameters as parameters and not hard-coded!

Mark Shuttleworth (sabdfl) wrote :

On 02/09/2013 01:42 PM, Paddy Landau wrote:
> But what about other developers who do not know or care about Ubuntu?

We can't do a great job supporting apps from developers who do not know
or care about Ubuntu. Others may offer to do a mediocre job of that for
you. We have an amazing community of developers who are building amazing
apps - by all means join us, but making demands doesn't work around here.

> As Niels Bohr said, "Prediction is very difficult, especially
> about the future."

About the past, however, we can be very clear. And the whitelist is most
definitely in the past, as we promised in 2009.

> 4. There are some well-respected and popular applications (such as
> TrueCrypt) that will no longer work when 13.04 comes around. Imagine the
> backlash. It's easy to say, "Oh, well, the application developers should
> change their code", but seriously, Canonical does not employ them. We
> depend on their goodwill and their time (not all developers are paid for
> their work).

You are depending on my goodwill and time right now ;)

Mark

Paddy Landau (paddy-landau) wrote :

OK, Mark, I understand.

Cliff Wells (cliff-develix) wrote :

I think the friction here is between Canonical, who are using Linux, GTK, et al as a platform to develop a "walled garden" type setup and those who see Ubuntu as "just another Linux distro". Yes, "walled garden" is a bit overstated being that Ubuntu remains open source, but given the limited resources that are an inherent limitation in most FOSS projects, the net result isn't too far off the mark.

As Mark repeatedly mentions, OSX does things this way to good effect. I think if you want a typical Linux distro, Ubuntu is the wrong place to look. Ubuntu is developing into its own OS, complete with incompatible desktop, utilities, APIs, etc. I'm not making a value judgement, merely pointing out that people who want a typical Linux distro are pretty much guaranteed to be disappointed. I'd also say the same thing about distros such as Elementary OS. They don't aim for compatibility, rather they want to push the desktop paradigm and compatibility is a drag on such an endeavor.

If you want a "Linux distro", there's plenty to choose from. If you want the "Canonical experience", whatever that may evolve to be, then stick with Ubuntu. Personally, I plan on moving to something else at some point because I seek the former (and am quite pleased with GNOME Shell these days), but I can see the futility of trying to hold back Ubuntu with legacy support.

Miguel (xadrezmiguelpires) wrote :

I don't see a friction here, I only see costumers/users that need something and is going to be taken a way.
For me, what was more surprising was see that people with responsability don't care/listen to the user/costumers. I read someone say they need some specific software that need this, and people from Canonical saying that is a not going to append, to that applications (like truecript) and for wine or java no problem if understand correctly).
Is a vision that I don't like! (to much resembles me other SO)
I'm one off the responsables of the decision of our company to completely switch from MS to Ubuntu, and what I read is not a good reading.
Sorry for share my "vision" off this "problem".

Cliff Wells (cliff-develix) wrote :

@Miguel

I think you miss the point: you probably aren't the customer they want. They want customers who buy into their vision, not customers who need X legacy application to run. No OS can please everyone, and it seems clear that Canonical's goals do not align with yours. I think you'll need to simply acknowledge that and move on. You are asking for a Chevy at the Ford dealership.

Mike M (hairy-palms-19) wrote :

at least this is foss, i fully expect someone to host a PPA with this commit reverted that people can use, so hopefully it shouldnt be too much of an issue for people who do really need it.

Miguel (xadrezmiguelpires) wrote :

@Cliff

I'm not saying Canonical have to please everyone. I say a complitly different thing. You need to listning to Costumers.
Look someone says in the first post this:
"If the whitelist was retired, Java and Wine would be hard-coded as the only software still able to use the menu bar as if it was a notification area, because their developers don't necessarily know that Ubuntu even exists."

The question is: Way this developers are different from the others?

More someone say that the tools they need to port is not ready to they can port to GTK3.
Soo way changing something that, for now can, put people of "Ubuntu" vision?

About Canonical vision whats is missing their?
- They whant to make Ubuntu TV (cool)
- They want to make UbuntuPhone OS (Cool)

For my business, the Ubuntu Phone OS, is going to be a interesting tool, if we solve the "porting" of programs need to our business.

How many accounting programs exist for Linux?
How many ERPS exist for Linux?

For me, is more important to mantain costumers, listning to them, try to help them, and try to find partners that want to port the specific programs to Ubuntu.
If not, in my humble opinion, is going to be another OS.

To resume everithing:
- I understand that they don't have to mantain this legacy software, but, some software can't, for now be ported, so, why don't wayt for a little more time, and when the tools that are needed to port are complited then do the moving,

- Start thinking more about whats is missing in the vision, in a global view.

- Do not tray to imitate some other OS, we are talking about Ubuntu OS, not OSX or other OS. Be Ubuntu!

Have a nice sunday

Paul Sladen (sladen) wrote :

Miguel/Cliff: it's a bit of a "backronym", but perhaps think of it this way. We have the *buntu core (kernels, system libraries, brand, fonts, …) on top of which are built several optimised distributions (remixes):

  KDE: [Ku]buntu
  LxDE: [Lu]buntu
  XDE: [Xu]ubuntu
  Unity: [U]buntu
  Gnome3 Shell: [G]ubuntu

There are other ones for Education, for GNOME 3 Shell, for music production, and dozens more. Each has a slightly different target; what they share is the core, the Debian packaging and the infrastructure, parts of the brand and five letters of the name.

Various people (mainly via Canonical) maintain/"garden" the infrastructure for most of these remixes, particularly the Launchpad service, the build daemons to build all the Debian packages and the main FTP servers to distribute them. And various people then make the specific remixes *work*: those people are often individuals, small companies (such as Blue Systems); often big companies (particularly via Canonical).

Now where people have their "day job" they are necessaryily going to be focused the dayjob since that's why they're being retained.

So, there's KDE people at Blue Systems who spend their time focused on the KDE parts of Kubuntu. There's Unity people in Canonical's Design/Desktop Experience team who spend their time focused on the Unity parts of Ubuntu. Kubuntu won't run Gnome 3 Shell applications without additional libraries/infrastructure; and GNOME3 Shell won't run KDE programs without additional libraries, and even when they are run as crossovers, the level of seemless integration will be less. The same is the case Unity, Enlightenment, and everything else: the integration with be less in a differing environment.

Miguel: you've particularly mentioned Unity/UbuntuPhone and Unity/UbuntuTV and it'll be good to see the apps targeted at these (it's not just you that thinks they're cool). You've also mentioned the various work applications (TrueCrypt), so the question is what are these targeting?

Are they targetting Ubuntu (Unity), or Gubuntu (GNOME3 Shell), or Kubuntu (KDE4). Do they know what their customers are wanting? There's quite a bit of "follow the money" here; if your company is a customer of the makers of a programme (you won't be the only one) then it really focuses the attention to _state that Unity support is required_.

Miguel (xadrezmiguelpires) wrote :

@Paul

First, i don't imply Ubuntu Phone OS or Ubuntu TV is cool because I think is cool. I say the vision is cool, have a unique OS for all, that was what I was saying. Like have the possibility to go to a reunion and use my phone and not have to carry my Laptop.

Second, Canonical have the right to do and decided what they whant, and me, have the right to say, Hey, why you don't wayt a little, for everione ajust or have the "tools" to make the change possible? (see #19)

Third, about the " There's quite a bit of "follow the money" here". Wher is the tools:

How many accounting programs exist for Linux?
How many ERPS exist for Linux?

If follow the mony is apply in this 2 examples, we and other companys, only going to change when, and if, the Software houses make the product to Linux. And believe me the only company I know of that have a ERP to Linux is SAP and it costs more then 2000% then all the software we have.

I hoppe I made my self clear about what I was traying to say.
Have a nice sunday, and yes i Know what truecript is, and what is for.

Ma Hsiao-chun (mahsiaochun) wrote :

Except some "old school" cooperate software that mentioned somebody else.

What about IBus, the default input method framework of Ubuntu.

It doesn't support AppIndicator yet.
On the other hand, it's the Ubuntu specific have half-broken patch make it play with Ubuntu.
http://bazaar.launchpad.net/~ubuntu-branches/ubuntu/raring/ibus/raring/view/head:/debian/patches/05_appindicator.patch

Why I say it is half broken?
It doesn't show input method specific context menu as upstream tray icon.
It has bug like: https://bugs.launchpad.net/ubuntu/+source/ibus/+bug/1023165

Another ugly thing is what if the manually compile ibus?
We have 1.4.2 for Raring.
What if the user try to compile latest 1.5.1 herself? Not usable in Unity?
1.5.x is not introduced in Raring for some reasons, but particular user may have different opinion.

Ed Guenter (edgue) wrote :

Working in the same company as Chris Giltnane does ... I can only agree.

If whitelisting stays disabled ... unity turns useless for me and the other ubuntu users in our company.
We will either turn to kubuntu/xubuntu ... or Redhat or Windows. If that is where you want to us to turn to, fine.

I am just a bit ashamed because I tried to convince many of my Linux-using coworkers in the past that unity is actually a great product and worth learning about.

Anton Piatek (anton-piatek) wrote :

Mark, I full appreciate your position and agree with direction, but you need to understand that this change would push nearly all enterprise users back to RedHat or even to things like Mint.

2009 is recent in enterprise terms, so spare a thought for those apps which have yet to be revisited for ubuntu updates (let alone those unlikely to have ubuntu-specific coding performed).

What is needed here is a cross-platform approach to allowing this sort of notification, so that developers aren't coding systray for windows, notification area for rhel, and new notifications for ubuntu. If you aren't building that, then you are walling off developers that aren't willing to spend time coding for a specific distribution, and you will find most of those will walk away...

I realise that is a hard goal to achieve, but don't make the mistake of forcing a new world without allowing the old to exist sensibly - Users won't appreciate it either, and Unity is having enough problems with rejection as it is already.

Jason Donahue (timekiller) wrote :

It's obvious Canonical is notgoing to listen to it's users here, so I have taken the steps necessary to make Ubuntu/Unity a usable environment. I have reverted this change and posted a ppa here:

https://launchpad.net/~timekiller/+archive/unity-systrayfix

to use it, of course:

sudo apt-add-repository ppa:timekiller/unity-systrayfix
sudo apt-get update
sudo apt-get upgrade

In addition, I have atached the diff necessary to back this change out. I plan to maintain the above PPA, but if for whatever reason I can't, or someone wants to roll their own Unity packages with this change reverted, here are the very easy steps:

save attached diff

mkdir my-unity
cd my-unity
bzr branch lp:ubuntu/unity
cd unity
patch -p1 < <path-to-saved-diff>
debuild -i -us -uc -b
cd ..
dpkg -i *.deb

Problem solved.

Bo Milanovich (deusdies) wrote :

I just don't see the reason why this had to be done. Why not leave it an option? Whitelisting is already "hidden" enough from the casual end-user so that s/he could not break it, but allows us to easily add legacy app support. And it worked. It worked just fine, in 99% of cases (in my particular case it was working 100% of times).

Marius B. Kotsbak (mariusko) wrote :

Jason, you might want to try to make a package recipe to automatically merge in the reverting of the commit from the latest Ubuntu code (publish a branch where it is done first).

mike stewart (mdrmike) wrote :

Maybe I'm missing the benefits of this change, but from my viewpoint, this change (1) removes choice and (2) lacks any utility or benefit; other than to draw a line to divide those that support Ubuntu from those that don't. Sounds a lot like Apple or Microsoft, or maybe George Bush: "My way or the highway." -- http://en.wikipedia.org/wiki/You%27re_either_with_us,_or_against_us -- but it doesn't come accross like community.

@Mark Shuttleworth: I'm sure many of us on this thread know and love Unity and have tons of respect for the vision of the Unity desktop. However, this change seems designed to force developers to choose the Ubuntu way without regard to its affect on end users. Obviously it will break more than only the Java/Wine applications that have now been hard coded to work with Unity. Please tell us there's more to the story besides "we told you (years ago) this was our plan, deal with it."

Maybe whats missing in the communication is something like: We're hoping that if we enact this change now, it'll bring to light the applications that need to be fixed, and together we'll be able to fix them by the time we get to 14.04 LTS. That would make sense to me, but it sure isn't implied.

By the way, kudos to #42 @Jason ... aka timekiller++ for bringing back choice and doing what community always does.

Mark Shuttleworth (sabdfl) wrote :

On 02/14/2013 09:55 PM, mike stewart wrote:
> Maybe whats missing in the communication is something like: We're hoping
> that if we enact this change now, it'll bring to light the applications
> that need to be fixed, and together we'll be able to fix them by the
> time we get to 14.04 LTS. That would make sense to me, but it sure
> isn't implied.

Mike, that's exactly what we gained by requiring apps to be whitelisted,
and maintaining a whitelist mechanism for three years. That's long
enough for a simple change on a key part of the UX. Community is not
about doing anything anyone wants, it's about finding a way forward.
That conversation kicked off three years ago.

Mark

Jason Donahue (timekiller) wrote :

Mark,
I fully understand the desire to move forward with Unity. I don't see how this change does that. Let me explain (and please, correct me where I am wrong):

* This is not a bug/security fix, no exploit is being fixed by removing the whitelist
* This is not a performance enhancement. There will be no speed increase with this change
* The whitelist is not blocking desired functionality - there is no new features that can be added once the whitelist is disabled.
* Keeping the whitelist would not negatively impact any other applications, or end user experience. I say this because the whitelist is off by default and there is no UI in Ubuntu to change it - if you make a change, it is HIGHLY likely you know what you are doing.
* Many of the programs this change breaks are in Ubuntu's own package repos. Things like guake, pidgin, _ALL_ kde apps (that use systray), etc will be broken by this change, but still offered in the defaul software list. Moreover, pidgin is Ubuntu approved! So, now 13.04 will presumably include pidgin, have the little ubuntu logo indicating it's tested and working, but will actually not work as expected. **You are breaking software you claim to support**

Also consider, you are not disabling the whitelist at all, all the functionality to implement a systray in the app indicator will be there for the foreseeable future to support Java and Wine.

So, my question is, why do Java and Wine get a pass ? Size of project ? Importance to end users ? Who makes the ultimate decision to say the Java and Wine teams can ignore Unity's App Indicator, but other teams can not ? What is gained ?

You keep mentioning "moving forward", but I have yet to see an explaination of what *specifically* turning this off accomplishes other than disappointing anyone who still needs systray.

Mark Shuttleworth (sabdfl) wrote :

On 02/15/2013 01:25 PM, Jason Donahue wrote:
> You keep mentioning "moving forward", but I have yet to see an
> explaination of what *specifically* turning this off accomplishes other
> than disappointing anyone who still needs systray.

For a start, it enables us to offer predictable and reliable keyboard
access to system menus. Better support for accessibility tools. Better
user experience. Sleeker design.

Folks, there is a difference between saying no, and not listening. I've
been on this thread since the beginning. You'll find ample commentary on
the topic from me and members of the team. It's not constructive to
construe disagreement and decision-making as hostile acts, especially on
the glacial timelines of this change.

Mark

Jason Donahue (timekiller) wrote :

Mark,
Thank you for answering. At least now I understand *why* you are doing this beyond "we want to". And thank you for keeping the project open source so I can say "no" to your "no" :)

For anyone interested, I have scripted a process that will check for updates to the raring unity package sources, download them, apply my patch, and if everything is successful, upload the repackaged source to my PPA. This should keep my PPA up to date with the official releases with minimal effort on my part.

Jakob Schmitt (jakob-schmitt) wrote :

I understand Mark's approach, at least for apps which aren't included in the repos, e.g. Truecrypt. Canonical has never claimed to support them.

For business users the LTS releases are recommended, anyway. With Ubuntu 12.04 they can still use systray for another 4 years. Then Ubuntu with Unity is either a major OS or legacy itself. In both cases we won't need systray in Unity anymore. If it's then still in today's market position, the removal of systray won't have had a big effect. So it's not worth to argue about it.

But I also agree with Jason. Users expect apps from the repos to work, especially those which are installed by default. To include apps from Debian makes only sense, if they work. I'm not sure, but isn't e.g. Vino included in the default installation of Ubuntu and needs whitelisting to work properly?

Ed Guenter (edgue) wrote :

So as Jason said ... Java and wine get a pass ... for how long?

And Jakob is right ... enterprise LTS users can stay on 12.04 for the next years; but there are other enterprise users who will want to update on a regular base; and not all of them might want to add yet another ppa to fix this.

So, kde and xfce, here we come.

Bye bye unity, as I just started to fall in love with you.

Matthew Paul Thomas (mpt) wrote :

Chris Giltnane and Ed Guenter: If you are under the impression that switching to RHEL will preserve the notification area, you should know that you'll just be jumping from one melting ice floe to another. <https://live.gnome.org/GnomeShell/Design/Guidelines/MessageTray/Compatibility>

Ma Xiaojun: IBus's notification area item should be supplanted by the text entry menu. <https://wiki.ubuntu.com/TextEntry#Menu>

Jakob Schmitt: According to bug 497883, Vino has had an indicator menu since August 2010.

mpt it seems your assumption is that we want to go, we don't, we really, really don't want to leave unity and Ubuntu. I am not a developer just a user but I have tried to help out with bug submissions and testing in the past. The problem we have is that we are being left with a stark choice, go back to 12.04 which was OK but not any where near as good as 12.10 is or 13.04 promises to be, or move some where else. There are two currently supported linux choices internally, RHEL or Ubuntu. If Ubuntu 13.04 onwards can't be used because we have stuff that, rightly or wrongly, is supplied needing systray whitelist then the only place to go is RHEL if we want support. Other DE's or Ubuntu flavours could be used but we would be on our own. I have absolutely no influence on the developers of the software I have to use at work, its mandated and I have to use it.
As just a user I am between a rock and a hard place on this, with two groups of developers who are going in divergent directions and apparently have no inclination to listen to me, effectively squeezing me out of Ubuntu. So please stop giving "useful" advice on how this is somehow my fault and that I should be careful what distro I move to because they may break me in the future. I did nothing more than use Ubuntu and comment on a bug when something I have to have got broke.

>> For a start, it enables us to offer predictable and reliable keyboard
>> access to system menus.

How can this be so, when Wine and Java apps are still supported? What makes them different than any other app that doesn't support appindicator? Isn't the fact that they are exceptions somewhat of an acknowledgment that this is a bad idea on some level? Where is the process to appeal for whitelisting of other apps by those of us who otherwise like Unity?

Leaving the whitelisting option is much better for everyone, because if an apps tray icon has to be whitelisted and causes problems, that's on the person who whitelisted it. If an app's whitelisted and works fine, all the better.

I have spent a lot of time and written a lot of words turning various peoples opinions around to a positive outlook on Unity, and this one change is all it took to drive me to KDE for as long as the programs I use are broken (which looks like forever, given their devs reactions), because I *need*, not *want*, to use those programs.

A wishlist bug that breaks third-party software becomes high priority because of its origin, rather than being evaluated on its technical merits? It seems that the real intent behind many of Canonical's recent decisions is to make ubuntu break away from the larger linux community.

Sergey Korablin (s-korablin) wrote :

Goodbye Ubuntu! You are not for human beings anymore... :-(

Stephen M. Webb (bregma) wrote :

Fix Released in Unity Unity 7.0.0 "R series".

Changed in unity:
status: Fix Committed → Fix Released

Was this 'bug' (actually wishlist) written backwards such that the 'Fix released' means "Wont Fix/breaking stuff", or am I reading that wrong?

Paddy Landau (paddy-landau) wrote :

@3vi1 - Reading the comments, I understand that this feature request was designed specifically to deliberately break applications that do not adhere to the standards that Canonical has adopted.

It is a pity, but we're unfortunately stuck with it.

If you have applications that break (you can test it in 13.04 already), you need to write requests to the developers in question; for example, X-Chat, TrueCrypt and yad (I have already written to the latter two, but received no response as yet). We depend on those developers' goodwill to change their applications, otherwise you need to use the patch kindly given to us by Jason Donahue — see comment #42.

Maxim Loparev (laplandersan) wrote :

So, just updated to 13.04 and don't see Java icons from davmail. What should i do?! Hipotetically, as i come here from this page https://launchpad.net/~timekiller/+archive/unity-systrayfix.

Olegch (olegch) wrote :

I also miss this functionality and would prefer this to be available out of the box in Ubuntu.

Meanwhile I found that "stalonetray" works very reliably as a replacement.
You can also try "trayer".

Note that stalonetray requires some configuration, at least put the following in ~/.stalonetrayrc
window_layer top
geometry 4x2+660+0
grow_gravity NW
icon_gravity NE

Trayer is less configurable but works out of the box.

Hope this helps

Luca Maranzano (liuk001) wrote :

I've upgraded from 12.04 LTS to 13.04 and for the moment I need to have some important applications like SpiderOak and Druva InSync workig fine, so kudos to #42 @Jason aka timekiller++ for his work, it works for me like a charm.
I'm a Unity fan, but it is not affordable for me to give up on important applications that I use only for this imposed constraint.
IMHO AppIndicator is really a good framework, but in general I think that users *must have* the possibility to choose to have support for the old deprecated systray, expecially becasue they do not have the control over the fact that the those applications are not (yet?) using AppIndicator for whatever reason.
I think that this is a sort of "freedom" that has always characterized the Open Source from which Linux (and Ubuntu) comes.
Just to be propositive, one way to spread the adoption of AppIndicator is to do the right "propaganda" about its advantages and features with the developers of the (most used?) applications that Ubuntu users are using.
I'll start with Druva just after this post ;-)
Just my 2 cents.

Luca

@Luca, FYI SpiderOak has released a new version that now uses an AppIndicator. I notified them about the upcoming changes several months ago, they made some noises about fixing it in time for Raring, and lo and behold! They did it just in time for the release.

Kirill Kabardin (kkabardin) wrote :

#42 Jason, you are the best! You just beat all superheroes at once in "Fight against evil corporation" contest.

Luca Maranzano (liuk001) wrote :

I'm happy to share with you that I already got a positive response from Druva about AppIndicator:

http://gsfn.us/t/2yv3x

I'm quite convinced that time is not yet mature to be so "drastic" in abandoning the systray.

Luca

Claude Durocher (claude-d) wrote :

Olegc #61, I think you have a very decent workaroud with "stalonetray".

Thank-you @Olegch, I found 'stalonetray' fixed this new Unity bug. Now my Chrome tray icon is back! More importantly, I can back up my laptop again, as that software only appears as a tray icon.

Canonical is making everything so hard for regular Ubuntu users; every time you upgrade now you have to become an expect Linux hacker just to repair the new things that Unity broken. One thing for sure, my next laptop won't be running Ubuntu :-(

John Kuang (xiphosurus) wrote :

I just filed Bug #1192020 which describes how Nautilus' file copy dialog cannot be reopened once closed due to it requiring the use of the system tray whitelist.

It is ironic that while "the application indicator system has been in place for two years now, which should be long enough for applications to adopt it", yet Ubuntu developers failed in this 2 years to ensure one of their own core applications is compliant.

John Lea (johnlea) on 2013-06-20
Changed in ayatana-design:
status: Fix Committed → Fix Released
Jan-Åke Larsson (jalar) wrote :

In my case it is davmail that has stopped working. (This is a java app that is suddenly not working - beats me why, since java is supposed to be in the hardcoded whitelist.)

I don't see the rationale here (not that someone cares). Since the compatibility code is going to stay (Wine, Java), why not enable it for all apps?

After using using 13.04 everyday for good couple months now, I just want to come and let the team know just how aggravating this decision still is every day. I don't care about Ubuntu's politics or disagreements with Linux app developers who don't care to adopt the 'Unity way'. I care that my day-to-day user experience is, and continues to be made needlessly frustrating.

Applications I use every day, like Google Chrome and JungleDisk, are still not working and still a pain to have to go kill them from the task list just because am forbidden by Mark's ideology from seeing the tray icon. Anti-user decisions driven by ideology is why my next laptop will definitely not be Linux; I know Mint is there and most people seem to be switching to that now; but it still the Ubuntu-based and I think these things are going to keep happening :-(

At least Microsoft brings back the start menu that is what users want. Pity the Ubuntu team values their users so much less.

I have been a proud Linux/Ubuntu user for eight years now, but this is the last straw for me.

asavah (irherder) wrote :

"Thanks" Ubuntu team ...
Guys, seriously, what the heck are you thinking about?
In 13.04 half of the apps which used the old good systray are now broken.
Unity way? no thanks.
Gnome team and canonical are breaking the ways we, linux users, were used to for YEARS.
And you guys seem to walk Microsoft's path.

I am sysadmin with 15 years working experience, I'm managing everything cisco devices to ms and linux/BSD servers and desktops.
Ubuntu was my favorite distro for years but now I realize that raring showuld have never been released as it is.
Gnome 3.4/3.8 is broken and hardly usable, Unity is going that way too.
Canonical/ubuntu developers need to realize that the motto "Ubuntu – Linux for Human Beings" needs to be changed to "We do what we please, screw you!".
If experienced people struggle to get ubuntu to behave as it should - what to say about plain users?

You guys have a serious problem and need to rethink you concepts.

Good-bye Ubuntu.

Henning Sprang (henning) wrote :

+1 about this decision is bad for usability and everything.

it breaks applications that are usually working just fine.

it was already bad enough that Ubuntu broke applications by default by not letting them show up in the notifications area - see https://bugs.launchpad.net/ubuntu/+source/unity/+bug/761587

Bow adding up soemthing that even makes it impossible to fixc this ug with a workaround seems not reasonable at all

please consider to revert this change.

oriolpont (oriolpont) wrote :

Me I also use a few legacy programs that need the notification area. My workaround (not mentioned yet): gnome-panel, with the "notification area" applet.

I use a single, very small, non-expanded panel with this and other applets I still use (invest applet, classic menu, and window selector) in an empty corner of the screen.

Paddy Landau (paddy-landau) wrote :

@oriolpont You'll see an excellent workaround in comment #42.

Luca Maranzano (liuk001) wrote :

Today my unity has been upgraded from 7.0.0daily13.04.18~13.04-0ubuntu1systray1 to 7.0.0daily13.06.19~13.04-0ubuntu1 and so.... no more systray :-(

May be that timekiller will update his PPA, but if you are impatient and you want to apply his systray patch and rebuild Unity the command to use for getting the right Unity source code is this:

 bzr branch lp:unity/7.0

HTH
Liuk

Paddy Landau (paddy-landau) wrote :

I see that Bug #721431 is marked as a duplicate. But it is not a duplicate; this bug says that we must disable certain apps, whereas Bug #721431 says that the Skype app is disabled and should not be disabled.

Please remove that bug from the list of duplicates.

Terry Zhou (zhouxc) wrote :

 Please get systray indicator back, there are a lot of legacy applications won't adopt to this like pidgin and stardict.

Jason Donahue (timekiller) wrote :

Luca: Just noticed the update. I've patched and uploaded a new version to my PPA. Just waiting for the packages to get built now.

Paddy Landau (paddy-landau) wrote :

@timekiller — is there any way for this to be automated? It would save you a load of hassle.

Teodor Milkov (tm-del) wrote :

Oop, they did it again - upgraded to 13.10 and my pidgin, workrave and other apps disappeared from the indicator area :-(

Paddy Landau (paddy-landau) wrote :

#80:

Please go to the following bugs and vote for each of them (click on the green writing near the top-right of each page). It may be worthwhile posting any relevant comments in those bugs, where applicable. Also, raise a new bug report for each of Pidgin, Workrave and the other apps.

Bug #1119420
Bug #721431
Bug #761587
Bug #587272
Bug #1192020

There may be other relevant ones of which I am not aware.

Please do *not* vote for this bug (bug #974480), because it would mean that you agree with removing the functionality!

To belatedly add my $0.02:

I'm a user of Rackspace's backup product Jungle Disk (https://jungledisk.com/). They provide Jungle Disk binaries for Linux, even packaging them as DEBs, which has made it very convenient to use with Ubuntu.

Unfortunately their software relies on a systray icon to provide the only entrance point for a user to get into the application. So if that icon is not available, the software becomes effectively unusable.

In the past I was able to use the whitelist to ensure that the icon would still be displayed, but that stopped working with the removal of the whitelist in Raring. When we reached the release of Saucy and the app was still not migrated to AppIndicator, I contacted Rackspace to ask if they had any plans to update it. Their response was that the app works fine in Precise, and since that's the most current LTS edition I should just use it instead of Raring/Saucy/etc. until a new LTS edition is released.

This indicates that retiring the whitelist in order to prod developers to update their software was kind of meaningless, since as long as 12.04 is supported they can just tell users to use that. And since 12.04 will be supported for a VERY long time, they can sit on this excuse for not updating until nearly 2018! So there's really not any particular pressure on them to do things the Right Way.

I understand the motivation for removing the whitelist, but since it was present in the most current long-lived LTS version removing it before the next LTS release just put users like me in the bind of either having to stick with 12.04 to support one app, or throwing away otherwise functional software. Which is not a great position to be in.

Paddy Landau (paddy-landau) wrote :

Jason, Mark Shuttleworth does not receive comments from this bug. Please add comments and your vote to the bugs listed in comment #81.

Mark Shuttleworth (sabdfl) wrote :

Hello Paddy ;)

Maxim Loparev (laplandersan) wrote :

desperately waiting for timekillers PPA update since upgrade to 13.10

Maxim Loparev (laplandersan) wrote :

Mark, meanwhile what do you think about tcltk and JavaFX toolkits. Shouldn't they exists in Ubuntu universe? To be precise i'm talking about tkabber and davmail packages which broken by this amazing decesion for more than a year now.

Paddy Landau (paddy-landau) wrote :

Comment #84 : Sorry, Mark, I really thought that you no longer saw this thread. I take back comment #83.

Rainer Rohde (rainer-rohde) wrote :

Skype no longer shows up in the indicator in 13.10, fresh install. Needless to say, Skype is actively running, I just can't get to it to control it without indicator...

Paddy Landau (paddy-landau) wrote :

@Rainer, I suggest that you raise a new bug.

Miloš Jakovljević (milos-sd) wrote :

Will you release packages for 13.10? :)

Miloš Jakovljević (milos-sd) wrote :

I installed Unity from unity-systray PPA on 13.10, but systray doesn't work.

Maxim Loparev (laplandersan) wrote :

@milos-sd That's empty autobuild according to the diff from saucy version https://launchpadlibrarian.net/155818257/unity_7.1.2%2B13.10.20131014.1-0ubuntu1_7.1.2%2B13.10.20131014.1-0ubuntu1systray1.diff.gz. The old patch can't be applied to the new sources, as it seems whole com.canonical.Unity.Panel schema missing. I guess some manual work needed here.

Jason Donahue (timekiller) wrote :

Finally got around to updating to 13.10 and find my patch no longer works. As Maxim stated com.canonical.Unity.Panel is not being used. So, now my ppa just whitelists everything.

Again, the ppa is here:

https://launchpad.net/~timekiller/+archive/unity-systrayfix

to use it, of course:

sudo apt-add-repository ppa:timekiller/unity-systrayfix
sudo apt-get update
sudo apt-get upgrade

I am attaching the (much more simplified) patch here.

Paddy Landau (paddy-landau) wrote :

Jason, thank you. We all appreciate your efforts.

Rick Harris (rickfharris) wrote :

Hear Hear!
Been using this patch for quite some time now, so big thanks for maintaining sanity for the desktop people.

However this previously working functionality is still spiralling in a downward direction.
QT applications no longer show up in the systray and I've never had sni-qt work at all.

Trying not to re-iterate what has largely already been said here regarding the amateurish breaking of applications that use the Linux DE standard systray (including nautilus file copy).

Just like to add that all QT applications that previously ran in the systray using this patch, now don't show up unfortunately :(

Maxim Loparev (laplandersan) wrote :

Hey Mark, can you please comment on this.
According to the origin of this bug "The application indicator system has been in place for two years now, which should be long enough for applications to adopt it."
Ok, i asked one of the (Debian) developers to consider to support it in some tk app(so as you don't provide tk bindings they should be created first). So he asked me about, surprize, documentation. And the questions are:

1) Do you think that application indicator system so popular and mature enough, so 3 of 4 links from the https://unity.ubuntu.com/projects/appindicators/ could lead to 404 pages

2)Do you think it's so cool that it even not worth to mention it at http://developer.ubuntu.com/api/

3) Is it really so hard to recognize your fail and revert the patch that breaks compatibility instead of forcing the world to play with your half supported/half abandoned API initiative?

Stephen M. Webb (bregma) wrote :

@Maxim Loparev

Thank you for making the effort to improve the Ubuntu desktop.

The status notifier specification is popular and mature enough that in the half-decade since it was first published, most desktop toolkits have implemented and integrated it.

You can find excellent documentation, including bindings for several popular languages and example code, starting from [1]. I'm sure the Tk bindings can build on one of the existing bindings.

A more effective way to address this would be in a mailing list or forum, rather than commenting on a fixed and released bug against the design of one particular desktop environment that also happens to use code that implements the specification. thank you for bringing the broken web links to our attention: once again filing a bug against the appropriate software is a more effective way to bring about improvement.

[1] http://www.freedesktop.org/wiki/Specifications/StatusNotifierIcon/

Maxim Loparev (laplandersan) wrote :

@Stephen

Thanks for the link.

> design of one particular desktop environment that also happens to use code that implements the specification
which developed this specification, forcefully dropped support of previous specification with similar functionality and obviously lacking the direction on maintaining consistent documentation on it's own resources.

Paddy Landau (paddy-landau) wrote :

@bregama — "… rather than commenting on a fixed and released bug…"

Fixed? How can you say "fixed"? This bug has broken packages, caused regressions, and fixed nothing whatsoever.

Stephen M. Webb (bregma) wrote :

@Paddy Landau

Not a single package in this bug is "broken" since they conform to the published status notifier specification, a common public specification developed through the freedesktop.org collaboration environment by a number of individuals representing various desktop toolkits, including but not limited to Unity and KDE. It has been adopted as standard by all common Free desktop environments except one.

Third-party software is free to implement the common specification or not. Should they choose to not implement it or use the functionality if available in their toolkit of choice, their software will not work well on Ubuntu or many of its flavours. We hope they would choose to work well with our product, but ultimately it's their decision and I assume they do not make it lightly.

You can either ask the developer of your favourite third-party software to support running their product on Ubuntu, or you can find an alternative that works better in this environment.

Maxim Loparev (laplandersan) wrote :

@Stephen

>Third-party software is free to implement the common specification or not. Should they choose to not implement it or use the functionality if available in their toolkit of choice, their software will not work well on Ubuntu or many of its flavours. We hope they would choose to work well with our product, but ultimately it's their decision and I assume they do not make it lightly.

It would be true if you'd really removed systray support completely, however you left hardcoded exception for Wine and Java which say - we don't really care about user experience as it's obvious that hardcoding exceptions for two non-linux native toolkits could not pass any QA. So we are just reducing customizability of our DE to just force developers to take our specs if they wanted to run apps on our DE. Funny thing that this other DE, which has not been adopted your specs, do the same - insulting own users by removing customization options.

Matthew Paul Thomas (mpt) wrote :

Maxim, the reason for excepting Wine and Java is stated in the last line of the bug description.

Anton Piatek (anton-piatek) wrote :

Whereas my c++ and python developers also may not know that Ubuntu exists,
so I am forced to use a PPA back port in a 6000 user corporate deployment
as they have no plans to rework their code in the next 5 years.

Paddy Landau (paddy-landau) wrote :

Matthew, the last line reads, "… Java and Wine would be hard-coded as the only software still able to use the menu bar as if it was a notification area, because their developers don't necessarily know that Ubuntu even exists."

You do realise that there are other developers who "don't necessarily know that Ubuntu even exists", don't you? If that is the rationale for excluding Java and Wine, then why aren't you excluding all other applications where this is the case?

This so-called bug-fix both contradicts itself and violates one of the first rules of programming — no hard-coding of parameters.

As you can tell by the volume of complaints, new bugs and related comments, this is not a bug-fix but rather a bug-creator. If Canonical really has a good reason for this change (i.e. apart from digging in your heels), it would be good to let us know.

Version 14.04 is nearly upon us, and there are still many applications, some of them international de facto standards, that have not been adapted and may not be in the reasonable future. It gives Ubuntu a bad reputation amongst users both new and old: "Why doesn't this work in Ubuntu? It works in Windows! (and OS X and Red Hat and previous Ubuntu versions)" — "Because Ubuntu deliberately broke it! Don't ask me why; they won't tell us!"

As a promoter of Ubuntu, this actually embarrasses me at times.

Matthew Paul Thomas (mpt) wrote :

Paddy, if you know of other popular runtimes that allow graphical applications with notification area elements to run on Ubuntu, where their developers are likely to be unaware of Ubuntu, please report those individually. (Anton's examples of C++ and Python don't fall into that category: they're just programming languages. And any Linux-specific runtime won't fall into that category either, since Ubuntu probably has more PC users than all other Linux distributions combined.) The same goes for those mysterious "international de facto standard" applications -- we can't do anything about them if they remain unnamed.

I don't know what you mean by "new bugs and related comments". This report does not have any duplicates, and even if it did, it would not be possible to tell anything in particular from their quantity, because people don't tend to report bugs of the form "my menu bar is too consistent and predictable". Opposition is usually noisier than agreement. And a primary reason this report has so many comments is that I and others have continued to answer your questions. I described the reason for abolishing the notification area nearly four years ago. <http://design.canonical.com/2010/04/notification-area/>

Paddy Landau (paddy-landau) wrote :

Matthew, thank you for posting that link. It would have been useful if I had had it when I previously requested third party developers to modify their programs. It is notable that two of those developers have not even bothered to reply to me; clearly, they don't care about Ubuntu (they obviously know about Ubuntu now that I have made the request).

If I understand you correctly, you want us to open a new bug for each and every third-party app that does not adhere to the Canonical standard, i.e. do not work correctly in 13.04 and above? Please confirm or correct me.

What about Java and Wine: have you attempted to negotiate with their developers? At the very least, they will become aware that Ubuntu exists, meaining that (according to the bug description) you can remove the whitelist altogether. I will be happy to contact them on your behalf if you are too busy.

Matthew Paul Thomas (mpt) wrote :

Paddy, yes, it may help to contact the developers of those applications -- though if they run their apps on Ubuntu at all, almost certainly they have realized by now that their notification area items don't show up by default.

The Ubuntu Developer site has a reference for using the indicator system. <http://developer.ubuntu.com/resources/technologies/application-indicators/>

And Gnome similarly advises that the notification area is deprecated, with an example of what to do instead. <https://wiki.gnome.org/Projects/GnomeShell/Design/Guidelines/MessageTray/Compatibility>

There is no issue with the developers of Java and Wine themselves. The issue is with the thousands of developers of applications that use Java or that run on Wine. It is not reasonable to expect a Windows application developer, for example, to check whether their app runs on Wine.

Paddy Landau (paddy-landau) wrote :

Thank you for your reply, Matthew. I have already contacted the most important of the apps in question, and while one of them was most helpful and has changed the package, the others have not even replied, such is their indifference.

I had understood you to mean that I should raise a bug report on this bug tracker; perhaps that is indeed a better way to go.

Ed Guenter (edgue) wrote :

Just wondering:

Would it be possible to create a new Ubuntu component that makes use of the new indicator system ... to display stuff that would otherwise go the system tray?

Matthew Paul Thomas (mpt) wrote :

Ed, as Paul Sladen explained in 2013-02-09, the notification area was basically a set of tiny windows: a program could put anything in its window, responding to clicks, right-clicks, double-clicks, drags, or anything else, and doing anything in response, including opening menus in any toolkit. As a simple example (unfortunately common on Windows), an item might open one menu on left-click and a different menu on right-click, with some of the items in those two menus being the same. Even if you came up with heuristics for merging two menus, there's no practical way that a hypothetical Ubuntu component could tell, ahead of time, that either action *would* open a menu, rather than, say, disconnect your Voip call.

Maxim Loparev (laplandersan) wrote :

So, trusty is here and i'm desperately waiting for the ppa update

Dear Mark,
 Since you are 'on' this thread...Please see this post from the perspective of some one who has been an unabashed fan of Ubuntu, Canonical and your personal investment into an open source OS with the aim of making it self sustaining ...all of which are noble goals and I fully appreciate the need to have it this way since it should survive beyond you and your personal finances...Having said that...(wait its not bashing time yet)

I think you're not respecting the power of lethargy and status quo and learning the lesson from Windows XP as well as can be done...inspite of the best efforts of MS to move people away from XP (discounts on upgrades)...currently there are people paying top dollar for keeping their dependencies going and these people have dedicated IT departments...instead of upgrading closed source commercial applications which they own....

You are asking nay demanding that open source developers follow a cathedral line where Open source has always been about the Bazaar....keep the options open and let people find their own path...what comes out popular may not be the best technically but it will help your cause win...what is more important to be right or be right now?

Sincerely,
A ubuntu lover tormented seeing the slow demise of a great movement ironically due to the SA nature of the BDFL...here is hoping that the SABDFL is open to some open thought

Dmitry Tantsur (divius) wrote :

Folks, all words were said and you already know how your users hate you for this decision. You already know that users of Cryptkeeper, Audacious and many more have to rely on PPA because you broke what was working without any (even theoretical) advantage for them. But I'm soory frustrated after 12.04 -> 14.04 upgrade, that I'm still writing this comment.

Of course, I don't pay you money and I can't demand anything. I must eat what I was given and shut up. You clearly showed me this. Thank you for opening my eyes.

Regards,
former Ubuntu fan.

varlesh (varlesh-l) wrote :

Liferea, Geary, Qutim, Venom and other necessary and good programs do not working as they should on Ubuntu 14.04.
Why do you deprive users habits and why you trim features? Why?
Everything worked fine before, why should all break???
I'm upset and disappointed!

Matthew Paul Thomas (mpt) wrote :

varlesh, I published our reasons for removing the notification area four years ago. <http://design.canonical.com/2010/04/notification-area/> If the apps you list claim to work on Ubuntu but do not, please report bugs to the developers of those apps.

Paddy Landau (paddy-landau) wrote :

@mpt, you can explain all you want, but it doesn't change the fact that this has broken a valuable part of Ubuntu. Does not the chorus of complaints mean something to you? We know that we want the developers to make their changes, but some developers simply just don't care (I know, because I have tried asking). Will it really break Ubuntu to put the whitelist back in?

Matthew Paul Thomas (mpt) wrote :

Paddy, no it doesn't mean anything in particular, for the reasons I gave you on January 6th.

Paddy Landau (paddy-landau) wrote :

@mtp, I have reported the most important (for me) applications in question and nothing has happened.

V字龍(Vdragon) (vdragon) wrote :

Hi,
Is it possible to implement a indicator for a place for those legacy software icons? People may shut up if there's still a way to access them.

Matthew Paul Thomas (mpt) wrote :

Vdragon, see my 2014-02-24 comment for why the notification area can't just be provided as an indicator.

Anton Piatek (anton-piatek) wrote :

mpt, that doesn't seem to me a reason why we can't have a drop down area for legacy apps. Yes their behaviour will be unpredictable for Ubuntu but it would still work for legacy apps.
I run a corporate repository for 6000 users and we are having to fix each unity version so our corporate apps work, or we have to move to RedHat. The corporate owners have no interest in fixing the apps for Ubuntu, and won't give out source code, so they won't be updated unless they move to a new library which does it for them (which is equally unlikely)

Paul Sladen (sladen) wrote :

Anton: I'm interested in understanding the situation a little better:

  1. Internal applications originally targeting eg. GNOME 2, and you're now needing to run these under Unity.
  2. Bought-in (external non-IBM) applications originally targeting eg. GNOME 2, and you're now needing to run these under Unity.
  3. Something else?

Anton Piatek (anton-piatek) wrote :

It is a bit of a mixture. Looking at my status bar (with hacked unity) I see an external (bought in) app - antivirus. Skype is sometimes quoted by others.

I also see two internal icons, which are related to our internal compliance.

I also have two IBM applications which are sold, and will try and pursue bugs against them internally as they are chat and email apps.

I've sent a bit more detail privately.

Matthew Paul Thomas (mpt) wrote :

Anton, the Skype package in the Ubuntu archives uses an application indicator via sni-qt.

There is systray whitelist patch and other patches for arch here https://github.com/chenxiaolong/Unity-for-Arch/tree/master/unity, right now i am compiling for utopic with this patch

Paddy Landau (paddy-landau) wrote :

@rezzafri See comment #42 for a patch that already whitelists the systray.

@paddy-landau, i'm aware of that ppa but no package for utopic yet. unity version on utopic up to now is 7.3.1+14.10.20141016-0ubuntu1. fyi, the patch on https://github.com/chenxiaolong/Unity-for-Arch/tree/master/unity works :D

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Related blueprints